


#include <stm32f10x.h>

#include "SPI.h"
#include "AD9834.h"
#include "Utilitaires.h"



extern unsigned char g_ValeursAEcrireSPI1[];



unsigned char EcrireDonnesAD9834(unsigned char Octet1, unsigned char Octet2)
{
	while((SPI1->SR & 0x0080) == 0x0080);	/* Bouclage tant que le module du SPI1 signale qu'il est occup. */

	GPIOA->BSRR = (1 << 2);	/* FSYNC_AD9834 = 1 */
	g_ValeursAEcrireSPI1[0] = Octet1;
	g_ValeursAEcrireSPI1[1] = Octet2;
	GPIOA->BSRR = (1 << (2 + 16));	/* FSYNC_AD9834 = 0 */
	EcrireSPI1(2);

	return 1;
}



unsigned char ReglerFrequenceAD9834(int Frequence)
{
	long ContenuRegistres;

	unsigned char F0, F1, F2, F3;

	ContenuRegistres = ((1 << 28) / AD9834_FREQUENCE_OSCILLATEUR);

	ContenuRegistres = (ContenuRegistres * Frequence);

	F0 = ((unsigned char)(0xFF & ContenuRegistres));
	F1 = ((unsigned char)((0x3F00 & ContenuRegistres) >> 8));
	F2 = ((unsigned char)((0x3FC000 & ContenuRegistres) >> 14));
	F3 = ((unsigned char)((0x0FC00000 & ContenuRegistres) >> 22));

	EcrireDonnesAD9834((AD9834_FREQUENCY_REGISTER_0 | F1), F0);	/* Ecriture des 14 bits de poids faible
																de la frquence du DDS AD9834,
																dans le  Frequency Register 0 . */
	
	EcrireDonnesAD9834((AD9834_FREQUENCY_REGISTER_0 | F3), F2);	/* Ecriture des 14 bits de poids fort
																de la frquence du DDS AD9834,
																dans le  Frequency Register 0 . */

	return 1;
}


