


#include <stm32f10x.h>

#include "SPI.h"

#include "Utilitaires.h"



#define TAILLE_TAMPON_ENVOI_SPI1 32



int g_LongueurTrameSPI1 = 0;

unsigned char g_ValeursAEcrireSPI1[TAILLE_TAMPON_ENVOI_SPI1] = {0x00};



void InitSPI1(void)
{
	RCC->APB2ENR |= (1 << 0);	/* Activation de l'horloge pour les fonctions alternatives d'entres - sorties. */
	RCC->APB2ENR |= (1 << 12);	/* Activation de l'horloge du SPI1. */

	GPIOA->CRL = ((GPIOA->CRL & 0xFFFFF00F) | 0x00000330);	/* Configurations des broches  PA1  et  PA2   en sortie de type  Push-Pull . */

	GPIOA->CRL = ((GPIOA->CRL & 0x0000FFFF) | 0xBBB30000);	/* Configurations des broches  PA4 ,  PA5 ,  PA6  et  PA7  pour les fonctions alternatives d'entres - sorties */
						
	SPI1->CR1 = 0x00004006;	/* Contenu du registre  SPI1->CR1  : 0b0100000001111110, ce qui correspond aux rglages indiqus ci-aprs,

							BIDIMODE = 0,
							BIDIOE = 1,
							CRCEN = 0,
							CRCNEXT = 0,
							DFF = 0, chaque transmission s'effectue sur 8 bits,
							CRCNEXT = 0, 
							RXONLY = 0,
							SSM = 0,
							LSBFIRST = 0, le bit de poids fort - le  MSB  - est ransmis en premier,
							MSTR = 1, le module du SPI1 fonctionne en tant que matre,
							CPOL = 1,
							CPHA = 1. */

	SPI1->CR1 |= (2 << 3);	/* Configuration de la vitesse du module SPI1  f PCLK / 2. */

	SPI1->CR2 |= (1 << 2);	/* SSOE = 1. */

	SPI1->CR1 |= (1 << 6);	/* Activation du module du SPI1,  n'effectuer qu'une fois que ce dernier ait t compltement configur, ce qui consiste  effectuer :

							SPE = 1 .*/
}

void InitITSPI1(void)
{
	NVIC->ISER[1] |= (1 << 3);   /* L'interruption qui correspond au SPI1 est situe en position 35,
dans la table des vecteurs. */
}

void SPI1_IRQHandler(void) __irq	/* Routine d'interruption appele par le module du SPI1. */
{
	static int ComptageOctetsEnvoyes = 0;

	if((SPI1->SR & 0x02) && (!(SPI1->SR & (1 << 7))))
	{
		ComptageOctetsEnvoyes++;

		if(ComptageOctetsEnvoyes < g_LongueurTrameSPI1)	/* Si le nombre d'octets qui ont dj t envoyes est infrieur au nombre total d'octets qui doivent tre envoys */
		{
			SPI1->DR = g_ValeursAEcrireSPI1[ComptageOctetsEnvoyes];	/* Envoi de l'octet suivant. */
		}
		else	/* Si le nombre d'octets qui ont dj t envoyes est suprieur au nombre total d'octets qui doivent tre envoys, on sait alors que l'envoi du dernier octet est termin */
		{
			ComptageOctetsEnvoyes = 0;
			SPI1->CR2 &= ~(1 << 7);	/* Interdiction des interruptions provoques par le module du SPI1. */
			GPIOA->BSRR = (1 << 2);	/* FSYNC_AD9834 = 1 */
		}
	}
	SPI1->SR = 0;	/* Rarmement de l'interruption appele par le module du SPI1. */
}

unsigned char EcrireSPI1(int Nombre)	
{
	g_LongueurTrameSPI1 = Nombre;

	SPI1->DR = g_ValeursAEcrireSPI1[0];	/* Envoi du premier octet par le module du SPI1. */
	SPI1->CR2 |= (1 << 7);	/* Autorisation des interruptions provoques par le module du SPI1. */

	return 1;
}


