


#include <stm32f10x_lib.h>

#include "SPI.h"
#include "Utilitaires.h"
#include "AD9834.h"



int main(void)
{
	RCC->APB2ENR |= (1 << 2);	/* Activation de l'horloge du port A. */
	
	GPIOA->CRH = ((GPIOA->CRH & 0xFFFFFFF0) | 0x00000003);	/* Configurations de la broche  PA8  en sortie de type  Push-Pull . */

	GPIOA->BSRR = (1 << (16 + 8));	/* RESET_AD9834 = 0 */

	GPIOA->BSRR = (1 << 8);	/* RESET_AD9834 = 1 */

	Delai(100000);

	GPIOA->BSRR = (1 << (16 + 8));	/* RESET_AD9834 = 0 */

	InitSPI1();

	InitITSPI1();

	GPIOA->BSRR = (1 << 2);

	GPIOA->BSRR = (1 << (16 + 8));	/* RESET_AD9834 = 0 */

	GPIOA->BSRR = (1 << 8);	/* RESET_AD9834 = 1 */

	Delai(100000);

	GPIOA->BSRR = (1 << (16 + 8));	/* RESET_AD9834 = 0 */

	Delai(100000);

	EcrireDonnesAD9834((AD9834_CONTROL_REGISTER | 0x21), 0x30);	/* Configurations du circuit AD9834.
							- Ecriture dans le  Frequency Register 0  en deux envois conscutifs,
							- Mise du circuit en  RESET ,
							- Activation de la broche  SIGN_BO ,
							- Connexion de la broche  SIGN_BO  au comparateur interne, afin de pouvoir produire un signal carr sur cette broche. */

	ReglerFrequenceAD9834(400);	/* Rglage d'une frquence de 400 Hz, connaissant la frquence de l'ocsillateur principal du circuit AD9834. */

	EcrireDonnesAD9834((AD9834_PHASE_REGISTER_0 | 0x00), 0x00);	/* Rglage d'une phase gale  0 radian. */

	EcrireDonnesAD9834((AD9834_CONTROL_REGISTER | 0x20), 0x30);	/* Configurations du circuit AD9834.
							- Ecriture dans le  Frequency Register 0  en deux envois conscutifs,
							- Activation de la broche  SIGN_BO ,
							- Connexion de la broche  SIGN_BO  au comparateur interne, afin de pouvoir produire un signal carr sur cette broche. */	

	while(1)
	{
		
	}
}



/* Fonction qui permet l'initialisation du microcontrleur STM32F100RB.

Paramtre d'entre :

Aucun.

Valeur de retour :

Aucune.

*/
void SystemInit (void)
{
	RCC->CR |= 0x01;
	while((RCC->CR & ~(1 << 1)) == 0x00);
	RCC->CR |= (1 << 16);
	while((RCC->CR & ~(1 << 17)) == 0x00);
	
	RCC->CFGR |= (4 << 18);
	RCC->CFGR |= (1 << 16);
	
	RCC->CFGR |= 0x02;
	
	RCC->CR |= (1 << 24);
	while((RCC->CR & ~(1 << 24)) == 0x00);
	RCC->CFGR |= 0x02;
}


